﻿Imports System
Imports System.IO.Ports
Imports System.Threading

Public Class Form1

    'DECLARE A COMM PORT 
    Dim WithEvents DACIO As SerialPort = New  _
    System.IO.Ports.SerialPort("COM1", _
                                115200, _
                                Parity.None, _
                                8, _
                                StopBits.One)


    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        'CHECK PORT IS OPEN - THEN CLOSE COMM PORT
        If DACIO.IsOpen Then
            DACIO.Close()
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim nameArray() As String

        ' Find the COM ports on the system.

        nameArray = SerialPort.GetPortNames
        Array.Sort(nameArray)

        ' Fill a combo box with the port names.

        cmbPorts.DataSource = nameArray
        cmbPorts.DropDownStyle = ComboBoxStyle.DropDownList

        ' Select a default port.

        cmbPorts.SelectedIndex = 1
    End Sub

    Private Sub btnConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConnect.Click
        'CHECK IF PORT IS CLOSED - THEN OPEN COM PORT FROM COMOBOX PORT NAMES        
        DACIO.PortName = cmbPorts.SelectedItem
        If Not DACIO.IsOpen Then
            DACIO.Open()
        End If
        'CONFIGURE PORTB AS AN OUTPUT PORT (CHANGE FOR YOUR SPECIFIC APPLICATION).
        If DACIO.IsOpen Then
            Tronix_lbl.Text = "COM Port Initialised"
            DACIO.Write("!SB=0;")
            'SET READ TIMOUT FOR RS232 READ TO 100MS
            DACIO.ReadTimeout = 100
            'READ DATA FROM RS232 INPUT BUFFER UP TO THE NEXT CR ( CHR(13))
            TextBox1.Text = (DACIO.ReadTo(Chr(13)))
        End If
    End Sub


    Public Sub New()
        ' This call is required by the designer.
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
    End Sub


    Private Sub Set_LEDRED_btn_Click(sender As Object, e As EventArgs) Handles Set_REDLED_btn.Click
        Try
            'SEND "!XLED=1;" OUT ON RS232 Port
            DACIO.Write("!XLED1=" + "1" + ";")
            'READ DATA FROM RS232 INPUT BUFFER UP TO THE NEXT CR ( CHR(13))
            TextBox1.Text = (DACIO.ReadTo(Chr(13)))
        Catch ex As TimeoutException
            'IF THERE IS A TIMEOUT, PRINT "Timed out - No Data" IN TEXTBOX1.TEXT
            TextBox1.Text = "Timed out - No Data"
            'THE NEXT LINE ENABLES A MSGBOX SCREEN WITH AN ERROR MESSAGE ( DELETE IF NOT REQUIRED)
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Clear_REDLED_btn_Click(sender As Object, e As EventArgs) Handles Clear_REDLED_btn.Click
        Try
            'SEND "!XLED=0;" OUT ON RS232 Port
            DACIO.Write("!XLED1=" + "0" + ";")
            'READ DATA FROM RS232 INPUT BUFFER UP TO THE NEXT CR ( CHR(13))
            TextBox1.Text = (DACIO.ReadTo(Chr(13)))
        Catch ex As TimeoutException
            'IF THERE IS A TIMEOUT, PRINT"Timed out - No Data" IN TEXTBOX1.TEXT
            TextBox1.Text = "Timed out - No Data"
            'THE NEXT LINE ENABLES A MSGBOX SCREEN WITH AN ERROR MESSAGE ( DELETE IF NOT REQUIRED)
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Get_A0_btn_Click(sender As Object, e As EventArgs) Handles Get_A0_btn.Click
        Try
            'SEND "!A0?;" OUT ON RS232 Port
            DACIO.Write("!A0?;")
            'READ DATA FROM RS232 INPUT BUFFER UP TO THE NEXT CR ( CHR(13))
            TextBox1.Text = (DACIO.ReadTo(Chr(13)))
        Catch ex As TimeoutException
            'IF THERE IS A TIMEOUT, PRINT"Timed out - No Data" IN TEXTBOX1.TEXT
            TextBox1.Text = "Timed out - No Data"
            'THE NEXT LINE ENABLES A MSGBOX SCREEN WITH AN ERROR MESSAGE ( DELETE IF NOT REQUIRED)
            MsgBox(ex.Message)
        End Try
    End Sub


End Class
